﻿using UnityEngine;
using System.Collections;
[System.Serializable]

public class PlayerController : MonoBehaviour
{
    public float movementSpeed = 0.05f;
    public float turnSpeed = 50f;
    public bool isTremor = false;
    Animator anim;
    Rigidbody localRigidBody;
    private SFXManager sfxman;

    public void Awake()
    {
        anim = GetComponent<Animator>();
        sfxman = FindObjectOfType<SFXManager>();
    }

    void Start()
    {
        localRigidBody = GetComponent<Rigidbody>();
    }

    void FixedUpdate()
    {
        UpdateInput();
        float turnAmount = Input.GetAxis("Horizontal");
        float moveAmount = Input.GetAxis("Vertical");

        //Calculate and apply the new position
        if (!isTremor)
        {
            Vector3 deltaTranslation = transform.position + transform.forward * movementSpeed * moveAmount * Time.deltaTime;
            localRigidBody.MovePosition(deltaTranslation);

            //Calculate and apply the new rotation

            if (Input.GetKey(KeyCode.RightArrow) || Input.GetKey(KeyCode.D) || Input.GetKey(KeyCode.LeftArrow) || Input.GetKey(KeyCode.A))
            {
                //sfxman.FootSteps.Play();
                Quaternion deltaRotation = Quaternion.Euler(turnSpeed * new Vector3(0, turnAmount, 0) * Time.deltaTime);
                localRigidBody.MoveRotation(localRigidBody.rotation * deltaRotation);
            }
        }

        if (isTremor)
        {
            Vector3 deltaTranslation = transform.position + transform.forward * -movementSpeed * moveAmount * Time.deltaTime;
            localRigidBody.MovePosition(deltaTranslation);

            //Calculate and apply the new rotation

            if (Input.GetKey(KeyCode.RightArrow) || Input.GetKey(KeyCode.D) || Input.GetKey(KeyCode.LeftArrow) || Input.GetKey(KeyCode.A))
            {
                //sfxman.FootSteps.Play();
                Quaternion deltaRotation = Quaternion.Euler(-turnSpeed * new Vector3(0, turnAmount, 0) * Time.deltaTime);
                localRigidBody.MoveRotation(localRigidBody.rotation * deltaRotation);
            }
        }
    }

    private void UpdateInput()
    {
        float move = Input.GetAxis("Vertical");
        anim.SetFloat("Speed", move);

        if(Input.GetKeyDown(KeyCode.Space))
        {
            isTremor = true;
        }
    }
}
