﻿using UnityEngine;
using System.Collections;
[RequireComponent(typeof(CharacterController))]
public class PlayerController : MonoBehaviour
{
    private Vector3 moveDirection = Vector3.zero;
    private Rigidbody localRigidBody;
    private Transform myTransform;
    public float rotateSpeed = 250;
    public float movementSpeed = 0.05f;

    public float turnSpeed = 50f;
    private CharacterController playerController;

    private bool isTremor = false;


    [Header("Camera Position Variables")]
    [SerializeField]
    float cameraDistance = 16f; //Distance from the tank that the camera should be
    [SerializeField]
    float cameraHeight = 16f;
    Transform mainCamera;       //Reference to the scene's main camera
    Vector3 cameraOffset;

    Animator anim;

    public void Awake()
    {
        myTransform = transform;
        localRigidBody = GetComponent<Rigidbody>();
        playerController = GetComponent<CharacterController>();

        cameraOffset = new Vector3(0f, cameraHeight, -cameraDistance);

        mainCamera = Camera.main.transform;

        anim = GetComponent<Animator>();
       
    }


    void Update()
    {
        UpdateInput();
      

    }

    private void UpdateInput()
    {
        float move = Input.GetAxis("Vertical");
        anim.SetFloat("Speed", move);


        if (Input.GetKeyDown(KeyCode.Space))
        {
            isTremor = true;
        }

        if (!isTremor)
        {
            if (Input.GetKey(KeyCode.UpArrow) || Input.GetKey(KeyCode.W))
                transform.Translate(Vector3.forward * movementSpeed * Time.deltaTime);

            if (Input.GetKey(KeyCode.DownArrow)||Input.GetKey(KeyCode.S))
                transform.Translate(-Vector3.forward * movementSpeed * Time.deltaTime);

            if (Input.GetKey(KeyCode.LeftArrow)||Input.GetKey(KeyCode.A))
                transform.Rotate(Vector3.up, -turnSpeed * Time.deltaTime);

            if (Input.GetKey(KeyCode.RightArrow)||Input.GetKey(KeyCode.D))
                transform.Rotate(Vector3.up, turnSpeed * Time.deltaTime);
        }

        else if (isTremor)
        {
            if (Input.GetKey(KeyCode.UpArrow))
                transform.Translate(-Vector3.forward * movementSpeed * Time.deltaTime);

            if (Input.GetKey(KeyCode.DownArrow))
                transform.Translate(Vector3.forward * movementSpeed * Time.deltaTime);

            if (Input.GetKey(KeyCode.LeftArrow))
                transform.Rotate(Vector3.up, turnSpeed * Time.deltaTime);

            if (Input.GetKey(KeyCode.RightArrow))
                transform.Rotate(Vector3.up, -turnSpeed * Time.deltaTime);
        }

       
    }

    void MoveCamera()
    {
        mainCamera.position = transform.position;   //...position the camera on the tank
        mainCamera.rotation = transform.rotation;   //...align the camera with the tank
        mainCamera.Translate(cameraOffset);     //...move the camera up and away from the tank
        mainCamera.LookAt(transform);               //...make the camera look at the tank
    }
}